<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <title>Task 38.35 Student Subject</title>
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container p-3">
    <div class="row">
      <div class="col-sm-12 text-center">
        <h3>F200 - LỊCH SỬ HỌC TẬP</h3>
      </div>
    </div>
    <div class="row form-group py-3 bg-light rounded">
      <label class="col-sm-2 col-form-label text-center"><b>Student</b></label>
      <div class="col-sm-3">
        <select id="select-student" class="form-control">
          <option value="0">== Select Student ==</option>
        </select>
      </div>
      <label class="col-sm-2 col-form-label text-center"><b>Subject</b></label>
      <div class="col-sm-3">
        <select id="select-subject" class="form-control">
          <option value="0">== Select Subject ==</option>
        </select>
      </div>
      <div class="col-sm-2">
        <button id="btn-filter" class="btn btn-primary w-100">Filter Data</button>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-12">
        <table id="table-grade" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>STT</th>
              <th>Student</th>
              <th>Subject</th>
              <th>Grade</th>
              <th>Exam Date</th>
            </tr>
          </thead>
          <tbody>

          </tbody>
        </table>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gStudents = [
    {
      id: 2,
      studentCode: "1356783",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      studyYear: 2015
    },
    {
      id: 3,
      studentCode: "1354363",
      firstname: "Nguyen Van",
      lastname: "Troi",
      age: 19,
      email: "troinv@gmail.com",
      studyYear: 2014
    },
    {
      id: 4,
      studentCode: "1354343",
      firstname: "Truong Ngoc",
      lastname: "Thi",
      age: 20,
      email: "thitn@gmail.com",
      studyYear: 2016
    },
    {
      id: 5,
      studentCode: "1545283",
      firstname: "Nguyen Van",
      lastname: "Thanh",
      age: 18,
      email: "thanhnv@gmail.com",
      studyYear: 2015
    },
    {
      id: 6,
      studentCode: "1350983",
      firstname: "Tran Ngoc",
      lastname: "Hai",
      age: 19,
      email: "haitn@gmail.com",
      studyYear: 2015
    },
    {
      id: 7,
      studentCode: "1998783",
      firstname: "Thai Van",
      lastname: "Lung",
      age: 21,
      email: "lungtvn@gmail.com",
      studyYear: 2014
    },
  ];

  var gSubjects = [
    {
      id: 5,
      subjectCode: "MATH101",
      subjectName: "Toán cao cấp 1"
    },
    {
      id: 6,
      subjectCode: "ENG101",
      subjectName: "Anh văn chuyên ngành 1"
    },
    {
      id: 7,
      subjectCode: "PHYS101",
      subjectName: "Vật lý đại cương 1"
    },
    {
      id: 8,
      subjectCode: "HIST101",
      subjectName: "Lịch sử thế giới 1"
    },
    {
      id: 9,
      subjectCode: "CHEM101",
      subjectName: "Hóa học đại cương 1"
    },
  ];

  var gGrades = [
    {
      id: 2,
      studentId: 2,
      subjectId: 5,
      grade: 8,
      examDate: "13/04/2021"
    },
    {
      id: 3,
      studentId: 2,
      subjectId: 6,
      grade: 6,
      examDate: "15/05/2021"
    },
    {
      id: 4,
      studentId: 4,
      subjectId: 7,
      grade: 8,
      examDate: "13/05/2021"
    },
    {
      id: 5,
      studentId: 5,
      subjectId: 8,
      grade: 8,
      examDate: "16/04/2021"
    },
    {
      id: 6,
      studentId: 7,
      subjectId: 9,
      grade: 8,
      examDate: "13/05/2021"
    },
    {
      id: 7,
      studentId: 6,
      subjectId: 8,
      grade: 9,
      examDate: "13/05/2021"
    },
    {
      id: 8,
      studentId: 5,
      subjectId: 6,
      grade: 7,
      examDate: "11/04/2021"
    },
    {
      id: 9,
      studentId: 3,
      subjectId: 5,
      grade: 4,
      examDate: "13/05/2021"
    },
    {
      id: 10,
      studentId: 2,
      subjectId: 9,
      grade: 9,
      examDate: "13/08/2021"
    },
    {
      id: 11,
      studentId: 5,
      subjectId: 6,
      grade: 6,
      examDate: "13/07/2021"
    },
  ];
  
  var gSTT = 1;

  const gTABLE_ROW = ["id", "studentId", "subjectId", "grade", "examDate"];
  const gSTT_COL = 0;
  const gSTUDENT_COL = 1;
  const gSUBJECT_COL = 2;
  const gGRADE_COL = 3;
  const gEXAM_DATE_COL = 4;

  var gTableGrade = $("#table-grade").DataTable({
    columns: [
      {data: gTABLE_ROW[gSTT_COL]},
      {data: gTABLE_ROW[gSTUDENT_COL]},
      {data: gTABLE_ROW[gSUBJECT_COL]},
      {data: gTABLE_ROW[gGRADE_COL]},
      {data: gTABLE_ROW[gEXAM_DATE_COL]},
    ],
    columnDefs: [
      {
        targets: gSTT_COL,
        render: function() {
          return gSTT++;
        }
      },
      {
        targets: gSTUDENT_COL,
        render: getStudentNameByStudentId
      },
      {
        targets: gSUBJECT_COL,
        render: getSubjectNameBySubjectId
      }
    ]
  })

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function() {
    // gán sự kiện tải trang/F5
    onPageLoading();
    // gán sự kiện click button Filter Data
    $(document).on("click", "#btn-filter", onBtnFilterClick);
  });
    
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // function xử lý sự kiện tải trang/F5
  function onPageLoading() {
    insertDataToTable(gGrades);
    loadStudentDataToSelect();
    loadSubjectDataToSelect();
  }

  // function xử lý sự kiện click button Filter Data
  function onBtnFilterClick() {
    // khai báo đối tượng chứa dữ liệu
    let vFilterData = {
      studentId: "",
      subjectId: ""
    };
    // B1: Thu thập dữ liệu
    getFilterData(vFilterData);
    // B2: Kiểm tra dữ liệu
    let vDataValid = checkFilterData(vFilterData);
    if (vDataValid) {
      // B3: Xử lý hiển thị
      let vFilteredObject = displayFilterDataTable(vFilterData);
      insertDataToTable(vFilteredObject);
    }
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // function thu thập dữ liệu filter data trên form
  // function return đối tượng paramFilterData được tham số hóa
  function getFilterData(paramFilterData) {
    paramFilterData.studentId = $("#select-student").val();
    paramFilterData.subjectId = $("#select-subject").val();
  }

  // function kiểm tra dữ liệu
  function checkFilterData(paramFilterData) {
    if (paramFilterData.studentId == "0" && paramFilterData.subjectId == "0") {
      alert("Please select Student and/or select Subject to filter data");
      return false;
    }
    return true;
  }

  // function filter student
  function filterStudent(paramStudentId) {
    let vFilterData = gGrades.filter(function(student) {
      return (student.studentId == paramStudentId)    
    })
    return vFilterData;
  }

  // function filter subject
  function filterSubject(paramSubjectId) {
    let vFilterData = gGrades.filter(function(subject) {
      return (subject.subjectId == paramSubjectId)    
    })
    return vFilterData;
  }

  // function hiển thị table sau khi filter data
  function displayFilterDataTable(paramFilterData) {
    let vStudentFilter = filterStudent(paramFilterData.studentId);
    let vSubjectFilter = filterSubject(paramFilterData.subjectId);
    let vFilteredData = [];
    // tường hợp user chỉ select Student
    if (vSubjectFilter.length == 0) {
      for (let bObject of vStudentFilter) {
        vFilteredData.push(bObject);
      }
    }
    // tường hợp user chỉ select Subject
    else if (vStudentFilter.length == 0) {
      for (let bObject of vSubjectFilter) {
        vFilteredData.push(bObject);
      }
    }
    // trường hợp user select cả Student và Subject
    else {
      for (let bStudentObject of vStudentFilter) {
        for (let bSubjectObject of vSubjectFilter) {
          if (bStudentObject.id == bSubjectObject.id) {
            vFilteredData.push(bStudentObject);
          }
        }
      }
    }
    return vFilteredData;
  }

  // function gán data cho Table
  function insertDataToTable(paramData) {
    gSTT = 1;
    gTableGrade.clear();
    gTableGrade.rows.add(paramData);
    gTableGrade.draw();
  }

  // function lấy tên Student theo studentId
  function getStudentNameByStudentId(paramStudentId) {
    let vIndex = 0;
    let vFound = false;
    let vStudentName = "";
    while (!vFound && vIndex < gStudents.length) {
      if (gStudents[vIndex].id == paramStudentId) {
        vStudentName = gStudents[vIndex].firstname + " " + gStudents[vIndex].lastname;
        vFound = true;
      }
      vIndex ++;
    }
    return vStudentName;
  }

  // function lấy tên Subject theo Subject ID
  function getSubjectNameBySubjectId(paramSubjectId) {
    let vIndex = 0;
    let vFound = false;
    let vSubjectName = "";
    while (!vFound && vIndex < gSubjects.length) {
      if (gSubjects[vIndex].id == paramSubjectId) {
        vSubjectName = gSubjects[vIndex].subjectName;
        vFound = true;
      }
      vIndex ++;
    }
    return vSubjectName;
  }

  // function load student data vào select
  function loadStudentDataToSelect() {
    for (let bStudent of gStudents) {
      $("#select-student").append(
        $("<option>")
          .val(bStudent.id)
          .text(bStudent.firstname + " " + bStudent.lastname)
      );
    }
  }

  // function load subject data vào select
  function loadSubjectDataToSelect() {
    for (let bSubject of gSubjects) {
      $("#select-subject").append(
        $("<option>")
          .val(bSubject.id)
          .text(bSubject.subjectName)
      );
    }
  }

</script>

</html>